3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
52 typeset profile="xvid"
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
77 (b) target_bitrate=$OPTARG;;
78 (s) target_size=$OPTARG;;
80 (v) make_final_dest_vob=1;;
81 (i) make_final_dest_iso=1;;
82 (f) make_final_dest_folder=1;;
83 (x) make_final_dest_comp=1;;
85 (k) keep_intermediate_files=1;;
86 (t) feature_title_override=$OPTARG;;
89 (e) extension=$OPTARG;;
92 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
100 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101 echo >&2 "Revision $REV"
103 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
104 echo >&2 " -n <dvdname> Specify a path to a DVD folder or file to process:"
105 echo >&2 " 1) If this option is not specified, the DVD will be ripped from $dev"
106 echo >&2 " 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107 echo >&2 " 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108 echo >&2 " 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109 echo >&2 " 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110 echo >&2 " -p <profile> Specify which encoding profile to use in -x mode as shown below:"
111 echo >&2 " - xvid = AVI, Xvid codec, 2 pass encoding, original aspect, no scaling (default)"
112 echo >&2 " - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
113 echo >&2 " - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
114 echo >&2 " - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
115 echo >&2 " - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
116 echo >&2 " - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
117 echo >&2 " -e <ext> Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
118 echo >&2 " If you run multiple instances of this script ripping the same DVD, you need to specify this option."
119 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
120 echo >&2 " The default operation is non-mirror mode where only the main"
121 echo >&2 " feature title will be ripped."
122 echo >&2 " -v Make the final image a DVD VOB file"
123 echo >&2 " -i Make the final image a DVD ISO file"
124 echo >&2 " -f Make the final image a DVD folder"
125 echo >&2 " -x Make the final image a compressed file based on your profile selection"
126 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
127 echo >&2 " -s <size> Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
128 echo >&2 " -b <bitrate> Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"
129 echo >&2 " -a <W:H> Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
130 echo >&2 " <W> If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
131 echo >&2 " The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
132 echo >&2 " -2 Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
133 echo >&2 " -k Keep the intermediate files (good for debugging)"
134 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
135 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
136 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
137 echo >&2 " -w Set the sh Execute/Verbose flag (causes every command to be echoed)"
142 if (($errors)) || (($show_usage))
147 # Sanity Check - Command Line Options
148 if [ "$dest" == "" ]; then
149 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
153 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
154 echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
158 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
159 echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
163 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
164 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
165 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
169 if [ $mirror_mode -eq 1 ]; then
170 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
171 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
172 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
177 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
178 if [ "$aspect" != "" ]; then
179 echo "$aspect" | grep -q "x"
181 echo "-E- You must specify the aspect option with a value whose format is W:H"
184 echo "$aspect" | grep -q ":"
186 SCALE=",scale -zoom -sws 9 -xy $aspect"
188 SCALE=",scale=$aspect"
193 # Sanity Check - Key executables
194 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
195 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
196 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
197 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
198 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
199 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
200 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
201 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
203 ##############################################################################################
206 if [ -z "$dvdname" ]; then
207 # make sure the DVD device is accessible
208 volname $dev > /dev/null 2>&1
210 echo "-E- Can't access the DVD device $dev"
213 # now capture the volume name from the device
214 dvdname=`volname $dev | awk '{ print $1 }'`
217 # check to see if dvdname is a full path to a real directory
218 # if it is, set dvdname and dvdpath appropriately
219 if [ -d "$dvdname" ]; then
221 dvdname=`basename "$dvdname"`
223 if [ -z "$dvdname" ]; then
224 echo "-E- Unable to extract dvdname from path: $dvdpath"
227 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
228 echo "-E- You must supply a full path to a valid DVD folder with this option"
233 # Check to see if dvdname is a full path to a file
234 if [ -f "$dvdname" ]; then
237 # check to see if dvdname is a full path to an MPG2 (VOB) file
238 # if it is, set dvdname and vobfile appropriately
239 file "$dvdname" | grep -q "MPEG"
241 # It is a valid MPEG2 file, now strip the extension off our dvdname
243 dvdname=`basename "$dvdname"`
244 dvdname=${dvdname%.[^.]*}
249 # check to see if dvdname is a full path to an ISO file
250 # if it is, set dvdname and isofile appropriately
251 file "$dvdname" | grep -q "ISO"
253 # It is a valid ISO file, now strip the extension off our dvdname
255 dvdname=`basename "$dvdname"`
256 dvdname=${dvdname%.[^.]*}
261 # If we didn't find a handler for the file above, complain
262 if [ $valid_file -eq 0 ]; then
263 echo "-E- Unsupported file type: $vobfile"
270 # remove bad characters from the dvdname
271 dvdname=${dvdname%.} # remove trailing '.' character
273 # add the suffix extension to the end of the dvdname
274 dvdname=$dvdname$extension
276 # make a "safe" dvdname (remove special characters)
277 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
279 # Make sure we have a non-empty dvdname
280 if [ -z "$dvdname" ]; then
281 echo "-E- unable to determine dvdname"
285 # make sure our vobfile value is set
286 if [ -z "$vobfile" ]; then
287 vobfile="$dest/$dvdname.VOB"
290 # set up some variables to hold various logfiles
291 logfile="$logdir/$dvdname.log"
292 passlogfile="$tmpdir/$safedvdname.log"
293 ddrescuelog=`tempfile`
294 dvdauthorlog=`tempfile`
298 # create the tmpdir if it doesn't already exist
299 if [ ! -d "$tmpdir" ]; then
302 echo "-E- Unable to create the tmpdir: $tmpdir"
307 # create the logdir if it doesn't already exist
308 if [ ! -d "$logdir" ]; then
311 echo "-E- Unable to create the logdir: $logdir"
316 ##############################################################################################
318 ##############################################################################################
320 if [ $keep_intermediate_files -eq 0 ]; then
321 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
322 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
323 [[ -e "$encodelog" ]] && rm -f "$encodelog"
324 [[ -e "$dumplog" ]] && rm -f "$dumplog"
326 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
327 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
328 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
329 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
335 if [[ -z "$1" ]]; then
336 msg="-E- control-c killed us"
340 echo -e 2>&1 "$msg" | tee -a "$logfile"
341 if [[ -n "$mailto" ]]; then
342 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
347 # Call our cleanup functions on INT and EXIT signals
348 trap fatal_and_exit INT
351 ##############################################################################################
352 # processing functions
353 ##############################################################################################
354 function make_dvd_iso_image {
358 # check to see if we have a dvdpath to rip from instead of $dev
359 if [ -z "$dvdpath" ]; then
360 # load the CSS codes in the DVD drive
361 lsdvd $dev >> "$logfile"
363 fatal_and_exit "-E- lsdvd $dev failed"
366 # read the DVD, ignoring/skipping CRC errors
367 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
369 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
371 cat "$ddrescuelog" >> "$logfile"
373 # rip from a path instead
374 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
378 function make_dvd_iso_image_from_folder {
384 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
386 # make an iso image out of our directory
387 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
388 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
390 # set the audio languages from the iso if it exists and is non-zero in size
391 if [ -s "$dst" ]; then
392 get_feature_title "$dst"
393 get_audio_id_from_iso "$dst"
396 # make sure we were able to create the iso image from the folder given to us
397 if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
398 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
399 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
400 # remove the bad iso file
401 [[ -e "$dst" ]] && rm -f "$dst"
402 # get the feature title from the DVD folder
403 get_feature_title "$dvdpath"
404 # create our main VOB file from the ISO
405 create_main_vob_with_mplayer "$dvdpath"
406 # get our audio id from the VOB file
407 get_audio_id_from_vob "$vobfile"
411 function make_dvdbackup_folder_image {
412 # extract the feature title from the DVD image
413 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
414 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
415 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
417 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
421 function make_dvdauthor_folder_image {
422 # create a new DVD video of the feature title
423 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
424 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
425 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
426 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
428 # There is a chance that dvdauthor won't like some of the VOBs.
429 # We can't tell ahead of time which ones it will choke on.
430 # So, we need to run it over and over again until it can process
431 # all the VOBs. If it can't handle one of them, run it through
432 # mencoder to fix it and try again. These errors are typically
433 # present due to the copy protection that ddrescue removed.
434 grep -q "SCR moves" $dvdauthorlog
435 while [ $? == 0 ]; do
436 # fix bad vobs that get the "SCR moves backwards" error:
437 # STAT: Processing VTS_01_0.VOB...
438 # ERR: SCR moves backwards, remultiplex input.
439 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
440 if [[ ! -f "$badvob" ]]; then
441 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
443 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
444 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
445 mv -f $badvob.fixed $badvob
446 echo "-> Creating DVD video $dest/$dvdname"
447 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
448 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
449 grep -q "SCR moves" $dvdauthorlog
453 function get_feature_title {
455 # if a feature title was given on the command line, use it
456 if [ $feature_title_override -ne 0 ]; then
457 feature_title=$feature_title_override
460 # otherwise, use lsdvd to figure it out
461 if [ $ripdvd -eq 1 ]; then
462 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
464 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
468 function create_main_vob_with_cat {
469 # cd to the feature title DVD folder
470 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
472 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
475 # concatenate all the VOBs together into 1 giant VOB
476 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
477 cat $vobs > "$tmpdir/$dvdname.VOB"
479 # cd back to the dir we started from
480 popd > /dev/null 2>&1
483 function create_main_vob_with_mplayer {
485 # argument processing
489 # make sure we have a valid feature title
490 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
491 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
494 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
495 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
496 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
497 msg="$msg We also detected another condition that requires us to use dumpstream. "
498 msg="$msg\n Unable to rip this DVD in the mode you requested."
499 fatal_and_exit "$msg"
502 # use mplayer to create the main VOB file
503 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
504 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
505 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
507 cat $dumplog | grep -v "^A:" >> "$logfile"
508 fatal_and_exit "-E- Mplayer Failed"
510 cat $dumplog | grep -v "^A:" >> "$logfile"
511 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
514 function get_audio_id_from_iso {
515 # Adjust our audio ID to find the english audio stream
516 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
520 mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
521 grep -q "aid: $aid" $aidcheck
522 while [ $? == 1 ] && [ $aid -lt 159 ]; do
524 grep -q "aid: $aid" $aidcheck
526 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
527 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
528 # mencoder default DVD audio track language selection (english)
529 lang_opts="-aid $aid -alang en"
532 function get_crop_from_iso {
534 echo "-> Detecting black frame border crop value from ISO file"
535 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
536 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
537 [[ -e "md5sums" ]] && rm -f "md5sums"
538 CROP=`cat $dumplog | grep CROP | tail -1`
539 echo " Found crop value of $CROP" >> "$logfile"
543 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
544 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
545 if [ -z "$CROP" ]; then
546 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
548 if [ $CROPCHECK -lt 0 ]; then
553 echo " Setting mencoder crop filter to: $CROP"
556 function get_crop_from_vob {
558 echo "-> Detecting black frame border crop value from VOB file"
559 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
560 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
561 [[ -e "md5sums" ]] && rm -f "md5sums"
562 CROP=`cat $dumplog | grep CROP | tail -1`
563 echo " Found crop value of $CROP" >> "$logfile"
567 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
568 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
569 if [ -z "$CROP" ]; then
570 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
572 if [ $CROPCHECK -lt 0 ]; then
577 echo " Setting mencoder crop filter to: $CROP"
580 function get_audio_id_from_vob {
581 # Adjust our audio ID to find the english audio stream
582 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
586 mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
587 grep -q "Found audio stream: $aid" $aidcheck
588 while [ $? == 1 ] && [ $aid -lt 159 ]; do
590 grep -q "Found audio stream: $aid" $aidcheck
592 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
593 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
594 # mencoder default DVD audio track language selection (english)
595 lang_opts="-aid $aid -alang en"
598 function check_vob_for_corrupted_start {
599 # check to see if the beginning of the DVD has a form of copy protection
600 # where they have deliberately broken the first X number of frames of the DVD.
601 # If we don't skip these, our resulting VOB file will not play.
602 badvobcheck=`tempfile`
605 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
607 fatal_and_exit "-E- Mencoder Failed"
609 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
610 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
611 (( skip = skip + 5 ))
612 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
613 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
615 fatal_and_exit "-E- Mencoder Failed"
617 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
619 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
621 # cat the giant VOB into mencoder to create a playable VOB file
622 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
624 fatal_and_exit "-E- Mencoder Failed"
628 function check_vob_for_completeness {
629 # check to make sure we got out a complete VOB.
630 # there is another kind of copy protection where the VOB's may
631 # have "MPG EOF" frames in the middle of the stream.
632 # this causes mencoder to not process the entire VOB, and exit without any errors.
633 # detect this by seeing how much smaller the dst vob is from the src vob.
634 MAX_FILESIZE_DELTA_PERCENT=70
635 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
636 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
637 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
638 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
639 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
640 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
641 create_main_vob_with_mplayer "$isofile"
642 [[ -e "$dumplog" ]] && rm -f $dumplog
643 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
644 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
645 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
646 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
651 function check_vob_for_too_many_video_packets {
652 # If our earlier algorithm to work around this failed, throw an error.
653 # check to see if this DVD has a protection scheme we don't know how to work around
654 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
655 # for some reason, the video is black, while the audio rolls, then the video finally comes
656 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
657 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
658 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
659 grep -q "Too many video packets in the buffer:" "$logfile"
661 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
662 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
663 create_main_vob_with_mplayer "$isofile"
664 grep -q "Too many video packets in the buffer:" $dumplog
666 [[ -e "$dumplog" ]] && rm -f $dumplog
667 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
669 [[ -e "$dumplog" ]] && rm -f $dumplog
673 function check_vob_for_a52_crc_errors {
674 # Let's see if we can playback our newly created VOB file without any errors.
675 # if there are issues, let's detect them now, and try to recreate the VOB
676 # there are some forms of copy protection that have missed above, that evidence
677 # themselves when we try to playback the VOB file. This was added to deal with
678 # the "a52: CRC check failed" copy protection scheme.
681 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
682 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
683 cat $dumplog | grep -v "^A:" >> "$logfile"
684 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
685 if [ $errors -gt $MAX_ERRORS ]; then
686 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
687 create_main_vob_with_mplayer "$isofile"
688 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
689 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
691 cat $dumplog | grep -v "^A:" >> "$logfile"
692 fatal_and_exit "-E- Mplayer Failed"
694 cat $dumplog | grep -v "^A:" >> "$logfile"
695 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
696 if [ $errors -gt $MAX_ERRORS ]; then
697 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
700 [[ -e "$dumplog" ]] && rm -f $dumplog
703 function calculate_bitrate_from_target_size {
704 # determine what our bitrate needs to be if a target size was specified instead
705 if [ $target_size -ne 0 ]; then
706 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
707 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
708 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
712 function create_dvdauthor_dvd_xml_file {
713 # make a dvdauthor xml menu file to create a valid DVD video from
714 # this script does a good job, but we'll still need to clean it up a bit after it runs
715 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
716 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
718 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
721 # replace the first line of the xml file to remove the bad dest path
722 awk -v line=1 -v new_content="<dvdauthor>" '{
728 }' dvd.xml > dvd.xml.new
729 mv -f dvd.xml.new dvd.xml
731 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
734 # remove the "<video " property line from the xml file
735 cat dvd.xml | grep -v "<video" > dvd.xml.new
736 mv -f dvd.xml.new dvd.xml
738 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
741 # remove the extra <pgc>..</pgc> pairs
742 cat dvd.xml | awk 'BEGIN {x=1}
744 if ($0~"</pgc>") {x=0}
746 if ($0~"<pgc>") {x=1}
748 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
749 mv -f dvd.xml.new dvd.xml
751 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
754 # remove the VTS_*_0.VOB file as this is just the main menu video clip
755 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
756 mv -f dvd.xml.new dvd.xml
758 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
762 function check_for_mplayer_dumpstream_incompatibility {
764 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
766 if [ ! -e "$vobfile" ]; then
767 # mplayer dumpstream does not work on DVDs that obscure the feature title.
768 # A DVD that has 99 titles, where the longest title isn't the main feature
769 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
770 # out what the feature title is. This script will run through that flow if we
771 # set use_mplayer_dumpstream to 0. Check for this here.
772 if [ $ripdvd -eq 1 ]; then
773 lsdvd $dev | grep -q "Title: 99"
775 lsdvd "$isofile" | grep -q "Title: 99"
777 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
778 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
779 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
780 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
781 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
782 echo " You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
783 invalid_feature_title=1
785 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
786 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
787 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
788 use_mplayer_dumpstream=0
789 invalid_feature_title=1
795 # There is another form of protection that causes the mplayer dumpstream to fail.
796 # This can be detected by telling mplayer to parse the VOB file by copying its audio
797 # video streams to a dummy output file (/dev/null). Do that here to check for that
798 # problem before continuing.
799 if [ -e "$vobfile" ]; then
800 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
801 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
802 grep -q "Too many audio packets in the buffer" $dumplog
804 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
805 use_mplayer_dumpstream=0
806 mplayer_dumpstream_incompatibility=1
808 [[ -e "$dumplog" ]] && rm -f $dumplog
812 # encode the vob file into a compressed file format
813 function compress_vob_file {
814 typeset -i found_profile=0
817 if [ "$profile" == "xvid" ]; then
819 final_output_file="$dest/$dvdname.avi"
820 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
821 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
822 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
823 mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
824 video_encoder_opts[0]="bitrate=$target_bitrate"
825 video_encoder_opts[1]="threads=$mencoder_threads"
826 video_encoder_opts[2]="chroma_opt"
827 video_encoder_opts[3]="vhq=4"
828 video_encoder_opts[4]="bvhq=1"
829 video_encoder_opts[5]="quant_type=mpeg"
830 video_encoder_opts[6]="autoaspect"
831 for OPTS in "${video_encoder_opts[@]}"; do
832 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
835 if [ $audio_2ch -eq 0 ]; then
836 # These options produce good 6 channel audio for linux and windows
837 mencoder_audio_opts="-oac copy"
838 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
839 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
840 mencoder_audioch_opts[1]="-af channels=6"
841 mencoder_audioch_opts[2]=""
843 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
844 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
845 mencoder_audioch_opts[0]=""
850 # MP4 encoding profiles
851 if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
853 final_output_file="$dest/$dvdname.mp4"
854 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
855 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
856 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
857 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
859 # Very High Quality (6fps)
860 if [ "$profile" == "mp4vhq" ]; then
861 video_encoder_opts[0]="bitrate=$target_bitrate"
862 video_encoder_opts[1]="threads=$mencoder_threads"
863 video_encoder_opts[2]="subq=6"
864 video_encoder_opts[3]="frameref=5"
865 video_encoder_opts[4]="bframes=3"
866 video_encoder_opts[5]="8x8dct"
867 video_encoder_opts[6]="me=umh"
868 video_encoder_opts[7]="b_pyramid"
869 video_encoder_opts[8]="weight_b"
870 video_encoder_opts[9]="partitions=all"
872 # High Quality (13fps)
873 if [ "$profile" == "mp4hq" ]; then
874 video_encoder_opts[0]="bitrate=$target_bitrate"
875 video_encoder_opts[1]="threads=$mencoder_threads"
876 video_encoder_opts[2]="subq=5"
877 video_encoder_opts[3]="frameref=2"
878 video_encoder_opts[4]="bframes=3"
879 video_encoder_opts[5]="8x8dct"
880 video_encoder_opts[6]="b_pyramid"
881 video_encoder_opts[7]="weight_b"
884 if [ "$profile" == "mp4" ]; then
885 video_encoder_opts[0]="bitrate=$target_bitrate"
886 video_encoder_opts[1]="threads=$mencoder_threads"
887 video_encoder_opts[2]="subq=4"
888 video_encoder_opts[3]="bframes=2"
889 video_encoder_opts[4]="b_pyramid"
890 video_encoder_opts[5]="weight_b"
893 for OPTS in "${video_encoder_opts[@]}"; do
894 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
897 if [ $audio_2ch -eq 0 ]; then
898 # These options produce good 6 channel audio for linux and windows
899 #mencoder_audio_opts="-oac copy"
900 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
901 #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
902 #mencoder_audioch_opts[1]="-af channels=6"
903 #mencoder_audioch_opts[2]=""
904 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
905 mencoder_audioch_opts[0]="-channels 6 -srate 48000"
907 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
908 #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
909 #mencoder_audioch_opts[0]=""
910 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
911 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
916 # iphone and ipod MP4 profiles
917 if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
919 if [ "$profile" == "iphone" ]; then
921 # scale width to 480, set height appropriately, but keep a multiple of 16
922 #SCALE=",scale=480:-10"
923 # scale the video down however far is necessary to fit in 480x320
924 SCALE=",dsize=480:320:0,scale=-8:-8"
927 # scale width to 320, set height appropriately, but keep a multiple of 16
928 #SCALE=",scale=320:-10"
929 # scale the video down however far is necessary to fit in 320x240
930 SCALE=",dsize=320:240:0,scale=-8:-8"
932 final_output_file="$dest/$dvdname.mp4"
933 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
934 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
935 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
936 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
937 video_encoder_opts[0]="bitrate=$target_bitrate"
938 video_encoder_opts[1]="threads=$mencoder_threads"
939 video_encoder_opts[2]="vbv_maxrate=1500"
940 video_encoder_opts[3]="vbv_bufsize=2000"
941 video_encoder_opts[4]="nocabac"
942 video_encoder_opts[5]="me=umh"
943 video_encoder_opts[6]="subq=6"
944 video_encoder_opts[7]="frameref=6"
945 video_encoder_opts[8]="trellis=1"
946 video_encoder_opts[9]="level_idc=30"
947 video_encoder_opts[10]="global_header"
948 video_encoder_opts[11]="bframes=0"
949 video_encoder_opts[12]="partitions=all"
950 for OPTS in "${video_encoder_opts[@]}"; do
951 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
954 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
955 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
958 if [ $found_profile -eq 0 ]; then
959 fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
962 # Do not edit this line. $mencoder_video_encoder_opts must be last
963 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
968 # Set some options based on which pass we are in
969 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
970 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
971 [ $PASS -eq 1 ] && output_file="/dev/null"
972 [ $PASS -eq 2 ] && output_file="$final_output_file"
974 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
975 for CH_OPTS in "${mencoder_audioch_opts[@]}";
977 echo -e " Encoding pass $PASS"
978 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
979 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
981 grep -q "\[channels\] Invalid" $encodelog
985 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
989 if [ $mencoder_retval != 0 ]; then
990 fatal_and_exit "-E- Unhandled mencoder error"
993 # Concatenate the encode log to our main log file, greping out unwanted lines
994 cat $encodelog | grep -v "Pos:" >> "$logfile"
999 function fill_mythvideo_metadata {
1001 # This function must be passed the filename as an argument
1002 # The filename must be a full path to the file
1005 # Make sure the fill mythvideo metadata option has been set to 1
1006 if [ $fill_mythvideo_metadata -eq 0 ]; then
1007 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1011 # If the fill mythvideo metadata script is present, run it
1012 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1013 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1014 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1015 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1017 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1018 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1022 # remove the intermediate VOB file
1023 function remove_intermediate_vob_file {
1024 if [ $keep_intermediate_files -eq 0 ]; then
1025 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1027 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1031 # remove the original DVD image
1032 function remove_intermediate_iso_file {
1033 [[ $keep_isofile -eq 1 ]] && return 1
1034 if [ $keep_intermediate_files -eq 0 ]; then
1035 [[ -e "$isofile" ]] && rm "$isofile"
1037 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1041 # remove the intermediate dvdbackup folder
1042 function remove_intermediate_dvdbackup_folder {
1043 if [ $keep_intermediate_files -eq 0 ]; then
1044 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1046 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1050 ##############################################################################################
1052 ##############################################################################################
1054 # Make a note of when this DVD rip started
1056 echo -e "\n$date DVD rip started" >> "$logfile"
1058 # Rip the DVD - Mirror Mode
1059 if [ $mirror_mode -eq 1 ]; then
1060 echo "-> Ripping DVD $dvdname to $dest"
1062 # use ddrescue to make an ISO image of the disk
1063 make_dvd_iso_image "$dest/$dvdname.iso"
1065 # add this video data to the mythtv DB
1066 fill_mythvideo_metadata "$dest/$dvdname.iso"
1068 # eject the disk upon completion
1072 echo "$date DVD rip completed" | tee -a "$logfile"
1074 if [[ -n "$mailto" ]]; then
1075 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1080 # Rip the DVD - Main Title Feature Only
1081 if [ $mirror_mode -eq 0 ]; then
1083 # Rip image from DVD
1084 if [ $ripdvd -eq 1 ]; then
1085 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1086 # use ddrescue to make an ISO image of the disk
1087 make_dvd_iso_image "$tmpdir/$dvdname.iso"
1090 # Rip image from DVD path
1091 if [ -n "$dvdpath" ]; then
1092 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1093 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1096 # make sure our isofile value is set
1097 if [ -z "$isofile" ]; then
1098 isofile="$tmpdir/$dvdname.iso"
1101 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1103 if [ ! -e "$vobfile" ]; then
1104 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1106 # get the feature title from the ISO
1107 get_feature_title "$isofile"
1109 # get the crop value from the ISO
1112 # check for mplayer dumpstream incompatibilities
1113 # if they exist, this method will set this mode to 0.
1114 check_for_mplayer_dumpstream_incompatibility
1116 if [ $use_mplayer_dumpstream -eq 1 ]; then
1118 # get our audio id from the ISO file
1119 get_audio_id_from_iso "$isofile"
1121 # create our main VOB file from the ISO
1122 create_main_vob_with_mplayer "$isofile"
1124 # remove the intermediate VOB file
1125 remove_intermediate_vob_file
1127 # it's possible that our VOB is still corrupted in some manner
1128 # check to make sure it is still a good VOB before continuing.
1129 check_for_mplayer_dumpstream_incompatibility
1133 if [ $use_mplayer_dumpstream -eq 0 ]; then
1135 # use dvdbackup to make a DVD folder of the feature title
1136 make_dvdbackup_folder_image
1138 # create our main VOB file
1139 create_main_vob_with_cat
1141 # get our audio id from the VOB file
1142 get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1144 # check for corrupted VOB start
1145 check_vob_for_corrupted_start
1147 # check to make sure our VOB is complete
1148 check_vob_for_completeness
1150 # check to make sure our VOB doesn't have too many video packets
1151 check_vob_for_too_many_video_packets
1153 # check to make sure our VOB doesn't have a52 crc errors
1154 check_vob_for_a52_crc_errors
1156 # remove the intermediate VOB file
1157 remove_intermediate_vob_file
1161 # remove the intermediate ISO file
1162 remove_intermediate_iso_file
1165 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1166 # get our audio id from the VOB file
1167 get_audio_id_from_vob "$vobfile"
1168 # get the crop value from the VOB
1172 # encode the VOB file to a compressed file format
1173 if [ $make_final_dest_comp -eq 1 ]; then
1174 echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1176 # determine what our bitrate needs to be if a target size was specified instead
1177 calculate_bitrate_from_target_size
1179 # encode the vob file into a compressed file format
1182 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1183 [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1184 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1186 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1187 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1191 # add this video data to the mythtv DB
1192 [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file"
1193 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
1197 # use dvdbackup to make a DVD folder of the feature title
1198 make_dvdbackup_folder_image
1200 # cd to the feature title DVD folder
1201 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1202 if [ $? != 0 ]; then
1203 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1206 # create the dvd.xml file for dvdauthor
1207 create_dvdauthor_dvd_xml_file
1209 # make the final DVD folder image
1210 make_dvdauthor_folder_image
1212 # add this video data to the mythtv DB
1213 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
1215 # cd back to the dir we started from
1216 popd > /dev/null 2>&1
1218 if [ $make_final_dest_iso -eq 1 ]; then
1220 # make an iso image out of our directory
1221 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1223 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1224 if [ -s "$dest/$dvdname.iso" ]; then
1225 if [ $make_final_dest_folder -eq 0 ]; then
1226 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1227 # remove the folder of the DVD image now that we have a .iso version of it
1228 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1231 # we created an empty iso file, remove it
1232 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1233 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1234 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1237 # add this video data to the mythtv DB
1238 fill_mythvideo_metadata "$dest/$dvdname.iso"
1244 # remove the ddrescue DVD ISO image
1245 remove_intermediate_iso_file
1247 # remove the tmp dvdbackup folder of the DVD image
1248 remove_intermediate_dvdbackup_folder
1250 # eject the DVD disk upon completion
1251 [ $ripdvd -eq 1 ] && eject -T $dev
1254 echo "$date DVD rip completed" | tee -a "$logfile"
1256 if [[ -n "$mailto" ]]; then
1257 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1262 ##############################################################################################